var BaseAnalytics;

(function() {
    var VERSION = 3, HTTP_ANALYTICS_URL = "http://static.getforecastfox.com/extension/${platform}/${version}/analytics.html", MAX_CACHED_MESSAGES = 50;
    BaseAnalytics = Class.extend({
        _KEY: "analytics-",
        _message_cache: [],
        init: function(logging, templator, datastore) {
            this._logger = logging.getLogger("analytics"), this._datastore = datastore;
            var doc = templator._document, self = this, url = templator.render(HTTP_ANALYTICS_URL, {
                version: VERSION,
                platform: Forecastfox.environment
            });
            this._node = this._installFrame(doc, url), this._install_platform_listeners(), setTimeout(function() {
                self._do_ping(), setInterval(function() {
                    self._do_ping();
                }, 216e5);
            }, 3e4), this._logger.debug("init complete");
        },
        _pinged: function(update_ping_time) {
            var last_ping = 0;
            return update_ping_time ? (last_ping = (new Date).toDateString(), this._datastore.set(this._KEY + "ping-time", last_ping), new Date(last_ping)) : (last_ping = this._datastore.get(this._KEY + "ping-time"), new Date(last_ping ? last_ping : 0));
        },
        _do_ping: function() {
            var last_ping = this._pinged(), current = new Date((new Date).toDateString());
            current > last_ping ? (this._logger.debug("pinging"), this.trackEvent("Operations", "ServicesLoad", "2.2.1"), this._pinged(!0)) : this._logger.debug("waiting to ping"), this._datastore.get(this._KEY + "installed") || (this._datastore.set(this._KEY + "installed", (new Date).valueOf() + ""), this.trackEvent("Operations", "Installed", "2.2.1"));
        },
        _installFrame: function(doc, url) {
            this._logger.error("installFrame unimplemented");
        },
        trackPageview: function(page) {
            this._logger.debug("tracking pageview: " + page), this._dispatch_message([ "_trackPageview", page ]);
        },
        trackEvent: function(category, action, optional_label, optional_value) {
            optional_value && optional_value == "HOUR" && (optional_value = (new Date).getHours()), optional_label !== undefined && optional_value === undefined && (optional_value = 1), this._logger.debug("tracking events: " + [ category, action, optional_label, optional_value ].join(", ")), this._dispatch_message([ "_trackEvent", category, action, optional_label, optional_value ]);
        },
        _dispatch_message: function(message) {
            this._send_message(message), this._message_cache.push(message), this._message_cache.length >= MAX_CACHED_MESSAGES && this._message_cache.shift();
        },
        _send_message: function(message) {
            try {
                var doc = this._node.contentWindow.document;
                $(function() {
                    var t = new Templator(logging, doc), e = doc.createEvent("Event");
                    e.initEvent("ext-to-web-event", !0, !1), t.node("#ext-to-web").append("<span>" + JSON.stringify(message) + "</span>"), t.node("#ext-to-web")[0].dispatchEvent(e);
                }, doc);
            } catch (e) {
                this._logger.debug("ERROR: trying to send message: " + e);
            }
        }
    });
})();