var I18n, DEFAULT_LOCALE;

(function() {
    var logger;
    DEFAULT_LOCALE = "en", I18n = Class.extend({
        _key: "locale",
        _supported: null,
        _cache: null,
        _datastore: null,
        init: function(logging, observers, datastore) {
            logger = logging.getLogger("i18n"), this._observers = observers, this._datastore = datastore, this._supported = this._filter(I18N_SUPPORTED), this._ensure_locale_exists(), this._load(DEFAULT_LOCALE, !0), this._load(this.locale()), logger.debug("initialized");
        },
        locale: function(code) {
            var supported = this.supported();
            return code && (code = $.localize.normalize(code), code in supported && supported[code].active && (logger.info("changing locale to: " + code), this._datastore.set(this._key, code), this._cache = code, this._load(code))), this._cache;
        },
        supported: function() {
            return this._supported;
        },
        accucode: function(locale) {
            locale || (locale = this.locale());
            var supported = this.supported();
            return locale in supported ? "accucode" in supported[locale] ? supported[locale].accucode : null : null;
        },
        rtl: function(locale) {
            locale || (locale = this.locale());
            var supported = this.supported();
            return locale in supported ? "dir" in supported[locale] ? supported[locale].dir == "rtl" : !1 : !1;
        },
        localize: function(templator) {
            var locale = this.locale();
            logger.debug("localizing a page with " + locale), templator.node("[rel*=localize]").localize("forecastfox", locale);
        },
        data: function(key, try_default_locale) {
            var locale = try_default_locale ? DEFAULT_LOCALE : this.locale();
            if (!!$.localize.data && locale in $.localize.data) {
                var value = $.localize.data[locale].forecastfox;
                return key in value && value[key] && value[key] != "" ? value[key] : try_default_locale ? (logger.error("missing i18n key: " + key), "") : (logger.warn("i18n key missing from current locale. trying default. key: " + key), this.data(key, !0));
            }
            return "";
        },
        has_data: function(key) {
            var keys = key.split(/\./), locale = this.locale();
            if (!!$.localize.data && locale in $.localize.data) {
                var value = $.localize.data[locale].forecastfox;
                while (keys.length > 0 && value) value = value[keys.shift()];
                return value && value != "";
            }
            return null;
        },
        all_data: function() {
            return $.localize.data;
        },
        _load: function(code, suppress_notification) {
            if (code in $.localize.data) {
                this._observers.notify("locale-ready", {
                    locale: code
                });
                return;
            }
            logger.debug("loading locale " + code);
            var self = this, options = {
                pathPrefix: [ "content", "locale" ].join("/"),
                language: code,
                callback: function(pkg, lang, data) {
                    logger.debug("locale " + code + " was loaded"), suppress_notification || self._observers.notify("locale-ready", {
                        locale: code
                    });
                }
            };
            $.localize.load("forecastfox", options);
        },
        _filter: function(d) {
            var filtered = {};
            return $.each(d, function(key, val) {
                val.active && (filtered[key] = val);
            }), filtered;
        },
        _ensure_locale_exists: function() {
            var code = this._datastore.get(this._key), supported = this.supported();
            code || (code = $.localize.browser);
            if (!(code in supported) || !supported[code].active) code = code.split("-")[0];
            if (!(code in supported) || !supported[code].active) code = DEFAULT_LOCALE;
            this._datastore.set(this._key, code), this._cache = code;
        }
    });
})();