// assume we have a page here
function Forecastfox_Inject_Options_Script(bgp, win) {
    var logging = bgp.logging, observers = bgp.observers, logger = logging.getLogger("options-content-script"), $_ = new bgp.Templator(logging, win.document), doc = win.document, obs_service = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    ForecastfoxOverlay.toggle_drag_icon(!0), win.addEventListener("unload", function() {
        logger.debug("window closed. cleaning up content script."), ForecastfoxOverlay.toggle_drag_icon(!1);
        try {
            obs_service.removeObserver(relayer.outbound, observers._topic());
        } catch (e) {
            logger.exception(e);
        }
        logging.removeLogger(logger);
    }, !1);
    if ("@maone.net/noscript-service;1" in Components.classes) {
        var noScript = Components.classes["@maone.net/noscript-service;1"].getService().wrappedJSObject, browser = getBrowser().getBrowserForDocument(win.document), sites = noScript.getSites(browser).filter(function(site) {
            return !this.isJSEnabled(site) && site != "http://www.google-analytics.com";
        }, noScript);
        if (sites.length > 0) {
            var notificationBox = getBrowser().getNotificationBox(), notification = notificationBox.getNotificationWithValue("forecastfox-noscript"), message = bgp.i18n.data("notification.message");
            if (notification) notification.label = message; else {
                var buttons = [ {
                    label: bgp.i18n.data("notification.button.label"),
                    accessKey: bgp.i18n.data("notification.button.accesskey"),
                    callback: function() {
                        sites.forEach(function(site) {
                            this.setJSEnabled(site, !0);
                        }, noScript), browser.reload();
                    }
                } ];
                const priority = notificationBox.PRIORITY_CRITICAL_MEDIUM;
                notificationBox.appendNotification(message, "forecastfox-noscript", bgp.themes.logo("16"), priority, buttons);
            }
            return;
        }
    }
    var relayer = {
        outbound: {
            observe: function(subject, topic, data) {
                logger.debug("Relaying message to web page");
                try {
                    var extToWeb = doc.createEvent("Event");
                    extToWeb.initEvent("extension-to-web-event", !0, !1), $_.node("#extension-to-web").append("<span>" + data + "</span>"), $_.node("#extension-to-web")[0].dispatchEvent(extToWeb);
                } catch (e) {
                    logger.exception("relay failed", e);
                }
            },
            QueryInterface: function(iid) {
                if (iid.equals(Components.interfaces.nsISupports) || iid.equals(Components.interfaces.nsISupportsWeakReference) || iid.equals(Components.interfaces.nsIObserver)) return this;
                throw Components.results.NS_ERROR_NO_INTERFACE;
            }
        },
        inbound: function() {
            var messages = $_.node("#web-to-extension span").remove().map(function() {
                return $_._$(this).html();
            });
            for (var x = 0; x < messages.length; x++) {
                var msg = messages[x];
                logger.debug("relaying msg to extension");
                try {
                    msg = bgp.JSON.stringify(bgp.JSON.parse(msg)), obs_service.notifyObservers(observers, observers._topic(), msg);
                } catch (e) {
                    logger.error("attempted to relay invalid message: " + msg);
                }
            }
        }
    };
    obs_service.addObserver(relayer.outbound, observers._topic(), !1), $_.node("#web-to-extension").bind("web-to-extension-event", relayer.inbound), relayer.inbound();
    function addClass(node, clazz) {
        var classes = node.className.split(" ");
        classes.push(clazz), node.className = classes.join(" ");
    }
    function removeClass(node, clazz) {
        var classes = node.className.split(" ");
        classes = classes.filter(function(o) {
            return o != clazz;
        }), node.className = classes.join(" ");
    }
    var flash_timers = [], drag_hint_hover = !1;
    function ff_flash_drag(count) {
        var panel = document.getElementById("forecastfox-drag-target");
        if (!panel) return;
        if (!drag_hint_hover && count >= 7) {
            removeClass(panel, "highlight");
            return;
        }
        for (var x = 0; x < flash_timers.length; x++) clearTimeout(flash_timers[x]), flash_timers = [];
        var addRemoveClass = count % 2 == 1 ? removeClass : addClass;
        flash_timers.push(setTimeout(function() {
            addRemoveClass(panel, "highlight"), ff_flash_drag(drag_hint_hover ? (count + 1) % 2 : ++count);
        }, 500));
    }
    $_.node("#drag-hint").hover(function() {
        drag_hint_hover = !0, ff_flash_drag(0);
    }, function() {
        drag_hint_hover = !1;
    });
    var prefs = ForecastfoxOverlay.services().preferences, href = win.location.href;
    matches = href.match(/^http:\/\/www\.getforecastfox\.com\/customize\/([#]{0,1}(.*))$/i);
    if (matches.length >= 2) {
        var page_version = matches[1].replace("/", ""), our_version = prefs.preference("version");
        page_version != our_version && (win.location.href += "../" + our_version + "/");
    }
    logger.debug("initialized");
}