var initialized = !1, logging = new Logging(LoggingLevels.NOTSET, undefined), logger = logging.getLogger("background-page");

try {
    var observers = new Observers(logging, OBSERVERS_CHANNEL, !0), datastore = new DataStore(logging), firefox_migrator = init_firefox_migrator(), MAX_FORECASTED_DAYS = 6, templator = new Templator(logging, document), i18n = new I18n(logging, observers, datastore), adapter = new AccuWeatherAdapter(logging, i18n, templator), preferences = new Preferences(logging, observers, datastore), converter = new Converter(logging, preferences, i18n, templator), processor = new AccuWeatherProcessor(logging, i18n, templator, converter), locations = new Locations(observers, preferences, adapter, processor, datastore), analytics = new Analytics(logging, new Templator(logging, document), datastore), positioner = new Positioner(logging, preferences, analytics), ui_dispatcher = new UIDispatcher;
    i18n.localize(templator);
    var themes = new Themes(logging, preferences, datastore), features = {};
    features["drag-target"] = new DragTarget(logging, preferences, i18n, themes), features.error = new ErrorReporter(logging, preferences, i18n, themes), features.progress = new ProgressIndicator(logging, preferences, i18n, themes), features.swa = new SWA(logging, preferences, i18n, themes), features.radar = new Radar(logging, preferences, i18n, themes), features.hourly = new HourlyLink(logging, preferences, i18n, themes), features.day5 = new Day5Link(logging, preferences, i18n, themes), features.cc = new CurrentConditions(logging, preferences, i18n, themes);
    for (var x = 0; x <= MAX_FORECASTED_DAYS; x++) features["forecast-" + x + "-day"] = new Forecast(x, "day", logging, preferences, i18n, themes), features["forecast-" + x + "-night"] = new Forecast(x, "night", logging, preferences, i18n, themes);
    observers.add("locale-ready", function() {
        i18n.localize(templator);
    }), observers.add("feed-ready", function() {
        update_feature_data();
    }), observers.add("preference-update", function() {
        update_feature_data();
    }), observers.add("locale-ready", function() {
        update_feature_data();
    });
    function update_feature_data() {
        var data = locations.processed_data();
        if (!data) return;
        for (var key in features) features[key].data(data);
    }
    function restore_all_defaults(are_you_sure) {
        are_you_sure && (datastore.clear(), locations.setup_default_locations(), preferences.preferences(PREFERENCES_DEFAULTS), locations.update_feed(locations.selected()), i18n.locale(DEFAULT_LOCALE));
    }
    initialized = !0, logger.debug("initialized"), observers.notify("background-page-ready", {}), window.addEventListener("unload", function() {
        logger.debug("window closed. cleaning up service script."), observers.shutdown(), logging.shutdown(), features = null, action = null, themes = null, ui_dispatcher = null, positioner = null, analytics = null, locations = null, processor = null, converter = null, adapter = null, templator = null, i18n = null, preferences = null, initialized = !1;
    }, !1);
} catch (e) {
    logger.exception("exception starting services", e);
}