/*******************************************************************************
 * Objects used by the front-end to take the backing data and render a feature.
 * The templator knows how to take a template and backing data and render
 * the template as html.  The templator uses the jquery.template plugin to
 * handle the actual templating.
 *
 *
 * @see /content/logging.js
 * @see /content/external/class.js
 * @see /content/external/jquery-1.3.2.js
 * @see /content/external/jquery.template.js
 * @version 1.0
 ******************************************************************************/var Templator = Class.extend({
    _logger: null,
    _document: null,
    _$: $,
    init: function(logging, doc) {
        this._logger = logging.getLogger("templator"), this._document = doc, this._logger.debug("initialized");
    },
    node: function(selector) {
        var node = $(selector, this._document);
        return node.size() === 0 && this._logger.warn("could not find a node for " + selector), node;
    },
    template: function(selector) {
        var node = this.node(selector);
        if (node.size() == 0) return null;
        var template = node.html();
        return template = template.replace(/\s*<!\[CDATA\[|\]\]>\s*/g, ""), template = template.replace(/[\r\n\t]/g, "\n"), template = unescape(template), template;
    },
    render: function(template, data, selector) {
        data = flatten(data);
        var newtemplate = template;
        return selector && (newtemplate = this.template(template)), $.template(newtemplate).apply(data);
    }
});

function flatten(object) {
    var newObject = {};
    return _flatten(object, [], newObject), newObject;
}

function _flatten(remaining, path, newObject) {
    for (var prop in remaining) {
        var newProp = path.concat([ prop ]);
        typeof remaining[prop] == "object" ? _flatten(remaining[prop], newProp, newObject) : newObject[newProp.join("-")] = remaining[prop];
    }
}